//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: cosmos/base/reflection/v2alpha1/reflection.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// ReflectionService defines a service for application reflection.
///
/// Usage: instantiate `Cosmos_Base_Reflection_V2alpha1_ReflectionServiceClient`, then call methods of this protocol to make API calls.
internal protocol Cosmos_Base_Reflection_V2alpha1_ReflectionServiceClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Cosmos_Base_Reflection_V2alpha1_ReflectionServiceClientInterceptorFactoryProtocol? { get }

  func getAuthnDescriptor(
    _ request: Cosmos_Base_Reflection_V2alpha1_GetAuthnDescriptorRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Base_Reflection_V2alpha1_GetAuthnDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetAuthnDescriptorResponse>

  func getChainDescriptor(
    _ request: Cosmos_Base_Reflection_V2alpha1_GetChainDescriptorRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Base_Reflection_V2alpha1_GetChainDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetChainDescriptorResponse>

  func getCodecDescriptor(
    _ request: Cosmos_Base_Reflection_V2alpha1_GetCodecDescriptorRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Base_Reflection_V2alpha1_GetCodecDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetCodecDescriptorResponse>

  func getConfigurationDescriptor(
    _ request: Cosmos_Base_Reflection_V2alpha1_GetConfigurationDescriptorRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Base_Reflection_V2alpha1_GetConfigurationDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetConfigurationDescriptorResponse>

  func getQueryServicesDescriptor(
    _ request: Cosmos_Base_Reflection_V2alpha1_GetQueryServicesDescriptorRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Base_Reflection_V2alpha1_GetQueryServicesDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetQueryServicesDescriptorResponse>

  func getTxDescriptor(
    _ request: Cosmos_Base_Reflection_V2alpha1_GetTxDescriptorRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Base_Reflection_V2alpha1_GetTxDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetTxDescriptorResponse>
}

extension Cosmos_Base_Reflection_V2alpha1_ReflectionServiceClientProtocol {
  internal var serviceName: String {
    return "cosmos.base.reflection.v2alpha1.ReflectionService"
  }

  /// GetAuthnDescriptor returns information on how to authenticate transactions in the application
  /// NOTE: this RPC is still experimental and might be subject to breaking changes or removal in
  /// future releases of the cosmos-sdk.
  ///
  /// - Parameters:
  ///   - request: Request to send to GetAuthnDescriptor.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func getAuthnDescriptor(
    _ request: Cosmos_Base_Reflection_V2alpha1_GetAuthnDescriptorRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Base_Reflection_V2alpha1_GetAuthnDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetAuthnDescriptorResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.base.reflection.v2alpha1.ReflectionService/GetAuthnDescriptor",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeGetAuthnDescriptorInterceptors() ?? []
    )
  }

  /// GetChainDescriptor returns the description of the chain
  ///
  /// - Parameters:
  ///   - request: Request to send to GetChainDescriptor.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func getChainDescriptor(
    _ request: Cosmos_Base_Reflection_V2alpha1_GetChainDescriptorRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Base_Reflection_V2alpha1_GetChainDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetChainDescriptorResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.base.reflection.v2alpha1.ReflectionService/GetChainDescriptor",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeGetChainDescriptorInterceptors() ?? []
    )
  }

  /// GetCodecDescriptor returns the descriptor of the codec of the application
  ///
  /// - Parameters:
  ///   - request: Request to send to GetCodecDescriptor.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func getCodecDescriptor(
    _ request: Cosmos_Base_Reflection_V2alpha1_GetCodecDescriptorRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Base_Reflection_V2alpha1_GetCodecDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetCodecDescriptorResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.base.reflection.v2alpha1.ReflectionService/GetCodecDescriptor",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeGetCodecDescriptorInterceptors() ?? []
    )
  }

  /// GetConfigurationDescriptor returns the descriptor for the sdk.Config of the application
  ///
  /// - Parameters:
  ///   - request: Request to send to GetConfigurationDescriptor.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func getConfigurationDescriptor(
    _ request: Cosmos_Base_Reflection_V2alpha1_GetConfigurationDescriptorRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Base_Reflection_V2alpha1_GetConfigurationDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetConfigurationDescriptorResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.base.reflection.v2alpha1.ReflectionService/GetConfigurationDescriptor",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeGetConfigurationDescriptorInterceptors() ?? []
    )
  }

  /// GetQueryServicesDescriptor returns the available gRPC queryable services of the application
  ///
  /// - Parameters:
  ///   - request: Request to send to GetQueryServicesDescriptor.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func getQueryServicesDescriptor(
    _ request: Cosmos_Base_Reflection_V2alpha1_GetQueryServicesDescriptorRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Base_Reflection_V2alpha1_GetQueryServicesDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetQueryServicesDescriptorResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.base.reflection.v2alpha1.ReflectionService/GetQueryServicesDescriptor",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeGetQueryServicesDescriptorInterceptors() ?? []
    )
  }

  /// GetTxDescriptor returns information on the used transaction object and available msgs that can be used
  ///
  /// - Parameters:
  ///   - request: Request to send to GetTxDescriptor.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func getTxDescriptor(
    _ request: Cosmos_Base_Reflection_V2alpha1_GetTxDescriptorRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Base_Reflection_V2alpha1_GetTxDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetTxDescriptorResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.base.reflection.v2alpha1.ReflectionService/GetTxDescriptor",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeGetTxDescriptorInterceptors() ?? []
    )
  }
}

internal protocol Cosmos_Base_Reflection_V2alpha1_ReflectionServiceClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'getAuthnDescriptor'.
  func makeGetAuthnDescriptorInterceptors() -> [ClientInterceptor<Cosmos_Base_Reflection_V2alpha1_GetAuthnDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetAuthnDescriptorResponse>]

  /// - Returns: Interceptors to use when invoking 'getChainDescriptor'.
  func makeGetChainDescriptorInterceptors() -> [ClientInterceptor<Cosmos_Base_Reflection_V2alpha1_GetChainDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetChainDescriptorResponse>]

  /// - Returns: Interceptors to use when invoking 'getCodecDescriptor'.
  func makeGetCodecDescriptorInterceptors() -> [ClientInterceptor<Cosmos_Base_Reflection_V2alpha1_GetCodecDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetCodecDescriptorResponse>]

  /// - Returns: Interceptors to use when invoking 'getConfigurationDescriptor'.
  func makeGetConfigurationDescriptorInterceptors() -> [ClientInterceptor<Cosmos_Base_Reflection_V2alpha1_GetConfigurationDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetConfigurationDescriptorResponse>]

  /// - Returns: Interceptors to use when invoking 'getQueryServicesDescriptor'.
  func makeGetQueryServicesDescriptorInterceptors() -> [ClientInterceptor<Cosmos_Base_Reflection_V2alpha1_GetQueryServicesDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetQueryServicesDescriptorResponse>]

  /// - Returns: Interceptors to use when invoking 'getTxDescriptor'.
  func makeGetTxDescriptorInterceptors() -> [ClientInterceptor<Cosmos_Base_Reflection_V2alpha1_GetTxDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetTxDescriptorResponse>]
}

internal final class Cosmos_Base_Reflection_V2alpha1_ReflectionServiceClient: Cosmos_Base_Reflection_V2alpha1_ReflectionServiceClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Cosmos_Base_Reflection_V2alpha1_ReflectionServiceClientInterceptorFactoryProtocol?

  /// Creates a client for the cosmos.base.reflection.v2alpha1.ReflectionService service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Cosmos_Base_Reflection_V2alpha1_ReflectionServiceClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// ReflectionService defines a service for application reflection.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Cosmos_Base_Reflection_V2alpha1_ReflectionServiceProvider: CallHandlerProvider {
  var interceptors: Cosmos_Base_Reflection_V2alpha1_ReflectionServiceServerInterceptorFactoryProtocol? { get }

  /// GetAuthnDescriptor returns information on how to authenticate transactions in the application
  /// NOTE: this RPC is still experimental and might be subject to breaking changes or removal in
  /// future releases of the cosmos-sdk.
  func getAuthnDescriptor(request: Cosmos_Base_Reflection_V2alpha1_GetAuthnDescriptorRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Base_Reflection_V2alpha1_GetAuthnDescriptorResponse>

  /// GetChainDescriptor returns the description of the chain
  func getChainDescriptor(request: Cosmos_Base_Reflection_V2alpha1_GetChainDescriptorRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Base_Reflection_V2alpha1_GetChainDescriptorResponse>

  /// GetCodecDescriptor returns the descriptor of the codec of the application
  func getCodecDescriptor(request: Cosmos_Base_Reflection_V2alpha1_GetCodecDescriptorRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Base_Reflection_V2alpha1_GetCodecDescriptorResponse>

  /// GetConfigurationDescriptor returns the descriptor for the sdk.Config of the application
  func getConfigurationDescriptor(request: Cosmos_Base_Reflection_V2alpha1_GetConfigurationDescriptorRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Base_Reflection_V2alpha1_GetConfigurationDescriptorResponse>

  /// GetQueryServicesDescriptor returns the available gRPC queryable services of the application
  func getQueryServicesDescriptor(request: Cosmos_Base_Reflection_V2alpha1_GetQueryServicesDescriptorRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Base_Reflection_V2alpha1_GetQueryServicesDescriptorResponse>

  /// GetTxDescriptor returns information on the used transaction object and available msgs that can be used
  func getTxDescriptor(request: Cosmos_Base_Reflection_V2alpha1_GetTxDescriptorRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Base_Reflection_V2alpha1_GetTxDescriptorResponse>
}

extension Cosmos_Base_Reflection_V2alpha1_ReflectionServiceProvider {
  internal var serviceName: Substring { return "cosmos.base.reflection.v2alpha1.ReflectionService" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "GetAuthnDescriptor":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Base_Reflection_V2alpha1_GetAuthnDescriptorRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Base_Reflection_V2alpha1_GetAuthnDescriptorResponse>(),
        interceptors: self.interceptors?.makeGetAuthnDescriptorInterceptors() ?? [],
        userFunction: self.getAuthnDescriptor(request:context:)
      )

    case "GetChainDescriptor":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Base_Reflection_V2alpha1_GetChainDescriptorRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Base_Reflection_V2alpha1_GetChainDescriptorResponse>(),
        interceptors: self.interceptors?.makeGetChainDescriptorInterceptors() ?? [],
        userFunction: self.getChainDescriptor(request:context:)
      )

    case "GetCodecDescriptor":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Base_Reflection_V2alpha1_GetCodecDescriptorRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Base_Reflection_V2alpha1_GetCodecDescriptorResponse>(),
        interceptors: self.interceptors?.makeGetCodecDescriptorInterceptors() ?? [],
        userFunction: self.getCodecDescriptor(request:context:)
      )

    case "GetConfigurationDescriptor":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Base_Reflection_V2alpha1_GetConfigurationDescriptorRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Base_Reflection_V2alpha1_GetConfigurationDescriptorResponse>(),
        interceptors: self.interceptors?.makeGetConfigurationDescriptorInterceptors() ?? [],
        userFunction: self.getConfigurationDescriptor(request:context:)
      )

    case "GetQueryServicesDescriptor":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Base_Reflection_V2alpha1_GetQueryServicesDescriptorRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Base_Reflection_V2alpha1_GetQueryServicesDescriptorResponse>(),
        interceptors: self.interceptors?.makeGetQueryServicesDescriptorInterceptors() ?? [],
        userFunction: self.getQueryServicesDescriptor(request:context:)
      )

    case "GetTxDescriptor":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Base_Reflection_V2alpha1_GetTxDescriptorRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Base_Reflection_V2alpha1_GetTxDescriptorResponse>(),
        interceptors: self.interceptors?.makeGetTxDescriptorInterceptors() ?? [],
        userFunction: self.getTxDescriptor(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Cosmos_Base_Reflection_V2alpha1_ReflectionServiceServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'getAuthnDescriptor'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeGetAuthnDescriptorInterceptors() -> [ServerInterceptor<Cosmos_Base_Reflection_V2alpha1_GetAuthnDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetAuthnDescriptorResponse>]

  /// - Returns: Interceptors to use when handling 'getChainDescriptor'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeGetChainDescriptorInterceptors() -> [ServerInterceptor<Cosmos_Base_Reflection_V2alpha1_GetChainDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetChainDescriptorResponse>]

  /// - Returns: Interceptors to use when handling 'getCodecDescriptor'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeGetCodecDescriptorInterceptors() -> [ServerInterceptor<Cosmos_Base_Reflection_V2alpha1_GetCodecDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetCodecDescriptorResponse>]

  /// - Returns: Interceptors to use when handling 'getConfigurationDescriptor'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeGetConfigurationDescriptorInterceptors() -> [ServerInterceptor<Cosmos_Base_Reflection_V2alpha1_GetConfigurationDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetConfigurationDescriptorResponse>]

  /// - Returns: Interceptors to use when handling 'getQueryServicesDescriptor'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeGetQueryServicesDescriptorInterceptors() -> [ServerInterceptor<Cosmos_Base_Reflection_V2alpha1_GetQueryServicesDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetQueryServicesDescriptorResponse>]

  /// - Returns: Interceptors to use when handling 'getTxDescriptor'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeGetTxDescriptorInterceptors() -> [ServerInterceptor<Cosmos_Base_Reflection_V2alpha1_GetTxDescriptorRequest, Cosmos_Base_Reflection_V2alpha1_GetTxDescriptorResponse>]
}
